<?php
/** List with all available otw sitebars
  *
  *
  */
global $_wp_column_headers;

$_wp_column_headers['toplevel_page_otw-sbm'] = array(
	'title' => esc_html__( 'Title', 'otw_sbm' ),
	'description' => esc_html__( 'Description', 'otw_sbm' ),
	'status' => esc_html__( 'Status', 'otw_sbm' ),
	'shortcode' => esc_html__( 'ShortCode', 'otw_sbm')

);

$otw_sidebar_list = get_option( 'otw_sidebars' );

$message = '';
$massages = array();
$messages[1] = esc_html__( 'Sidebar saved.', 'otw_sbm' );
$messages[2] = esc_html__( 'Sidebar deleted.', 'otw_sbm' );
$messages[3] = esc_html__( 'Sidebar activated.', 'otw_sbm' );
$messages[4] = esc_html__( 'Sidebar deactivated.', 'otw_sbm' );
$messages[5] = esc_html__( 'Sidebar duplicated.', 'otw_sbm' );


if( isset( $_GET['message'] ) && isset( $messages[ $_GET['message'] ] ) ){
	$message .= $messages[ $_GET['message'] ];
}


?>
<?php if ( $message ) : ?>
<div id="message" class="updated"><p><?php echo esc_html( $message ); ?></p></div>
<?php endif; ?>
<div class="wrap">
	<div id="icon-edit" class="icon32"><br/></div>
	<h2>
		<?php esc_html_e('Available Custom Sidebars', 'otw_sbm') ?>
		<a class="button add-new-h2" href="admin.php?page=otw-sbm-add"><?php esc_html_e('Add New', 'otw_sbm') ?></a>
	</h2>
	
	<form class="search-form" action="" method="get">
	</form>
	
	<br class="clear" />
	<?php if( is_array( $otw_sidebar_list ) && count( $otw_sidebar_list ) ){?>
	<table class="widefat fixed" cellspacing="0">
		<thead>
			<tr>
				<?php foreach( $_wp_column_headers['toplevel_page_otw-sbm'] as $key => $name ){?>
					<th><?php echo esc_html( $name )?></th>
				<?php }?>
			</tr>
		</thead>
		<tfoot>
			<tr>
				<?php foreach( $_wp_column_headers['toplevel_page_otw-sbm'] as $key => $name ){?>
					<th><?php echo esc_html( $name )?></th>
				<?php }?>
			</tr>
		</tfoot>
		<tbody>
			<?php foreach( $otw_sidebar_list as $sidebar_item ){?>
				<tr>
					<?php foreach( $_wp_column_headers['toplevel_page_otw-sbm'] as $column_name => $column_title ){
						
						$edit_link = admin_url( 'admin.php?page=otw-sbm&amp;action=edit&amp;sidebar='.$sidebar_item['id'] );
						$delete_link = admin_url( 'admin.php?page=otw-sbm-action&amp;sidebar='.$sidebar_item['id'].'&amp;action=delete' );
						$copy_link = admin_url( 'admin.php?page=otw-sbm-action&amp;sidebar='.$sidebar_item['id'].'&amp;action=copy' );
						$status_link = '';
						switch( $sidebar_item['status'] ){
							case 'active':
									$status_link = admin_url( 'admin.php?page=otw-sbm-action&amp;sidebar='.$sidebar_item['id'].'&amp;action=deactivate' );
									$status_link_name = esc_html__( 'Deactivate', 'otw_sbm' );
								break;
							case 'inactive':
									$status_link = admin_url( 'admin.php?page=otw-sbm-action&amp;sidebar='.$sidebar_item['id'].'&amp;action=activate' );
									$status_link_name = esc_html__( 'Activate', 'otw_sbm' );
								break;
						}
						switch($column_name) {

							case 'cb':
									echo '<th scope="row" class="check-column"><input type="checkbox" name="itemcheck[]" value="'. esc_attr($sidebar_item['id']) .'" /></th>';
								break;
							case 'title':
									echo '<td><strong><a href="'.esc_attr( $edit_link ).'" title="'.esc_attr(sprintf(__('Edit &#8220;%s&#8221;', 'otw_sbm'), $sidebar_item['title'])).'">'.$sidebar_item['title'].'</a></strong><br />';
									
									echo '<div class="row-actions">';
									echo '<a href="'.esc_attr( $edit_link ).'">' . esc_html__('Edit', 'otw_sbm') . '</a>';
									echo ' | <a href="'.esc_attr( $delete_link ).'">' . esc_html__('Delete', 'otw_sbm'). '</a>';
									if( $status_link ){
									echo ' | <a href="'.esc_attr( $status_link ).'">' . $status_link_name. '</a>';
									}
									echo ' | <a href="'.esc_attr( $copy_link ).'">' . esc_html__('Duplicate', 'otw_sbm'). '</a>';
									echo '</div>';
									
									echo '</td>';
								break;
							case 'description':
									echo '<td>'.$sidebar_item['description'].'</td>';
								break;
							case 'status':
									switch( $sidebar_item['status'] ){
										case 'active':
												echo '<td class="sidebar_active">'.esc_html__( 'Active', 'otw_sbm' ).'</td>';
											break;
										case 'inactive':
												echo '<td class="sidebar_inactive">'.esc_html__( 'Inactive', 'otw_sbm' ).'</td>';
											break;
										default:
												echo '<td>'.esc_html__( 'Unknown', 'otw_sbm' ).'</td>';
											break;
									}
								break;
							case 'shortcode':
									if( !isset( $sidebar_item['replace'] ) || empty( $sidebar_item['replace'] ) ){
										echo '<td>[otw_is sidebar='.$sidebar_item['id'].']</td>';
									}else{
										echo '<td>&nbsp;</td>';
									}
								break;
						}
					}?>
				</tr>
			<?php }?>
		</tbody>
	</table>
	<?php }else{ ?>
		<p><?php esc_html_e('No custom sidebars found.', 'otw_sbm')?></p>
	<?php } ?>
</div>
